unit musicd3;

interface

uses
  musicd0,
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TSettingDialog = class(TForm)
    BtnOK: TButton;
    BtnCancel: TButton;
    Bevel1: TBevel;
    GrpKeyCount: TRadioGroup;
    ChkFixedStart: TCheckBox;
    ChkPlayTunes: TCheckBox;
    ChkBlackKeys: TCheckBox;
    GrpSpeed: TGroupBox;
    ScrlSpeed: TScrollBar;
    LblSlow: TLabel;
    LblFast: TLabel;
    BtnDefault: TButton;
    LblSpeed: TLabel;
    procedure BtnDefaultClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ScrlSpeedChange(Sender: TObject);
  private
    procedure SetValues;
    procedure GetValues;
  public
    GameSettings : T_GameSettings;
  end;

var
  SettingDialog: TSettingDialog;

implementation

{$R *.DFM}

{ private }

procedure TSettingDialog.SetValues;
begin with GameSettings do begin
  GrpKeyCount.ItemIndex := KeyCount - GC_MinKeyCount;
  ChkFixedStart.Checked := FixedStart;
  ChkPlayTunes.Checked  := PlayTunes;
  ChkBlackKeys.Checked  := BlackKeys;
  LblSpeed.Caption      := IntToStr(Speed);
  ScrlSpeed.SetParams(Speed,GC_MinSpeed,GC_MaxSpeed);
end end;

procedure TSettingDialog.GetValues;
begin with GameSettings do begin
  KeyCount   := GrpKeyCount.ItemIndex + GC_MinKeyCount;
  FixedStart := ChkFixedStart.Checked;
  PlayTunes  := ChkPlayTunes.Checked;
  BlackKeys  := ChkBlackKeys.Checked;
  Speed      := ScrlSpeed.Position;
end end;

{ generated }

procedure TSettingDialog.BtnDefaultClick(Sender: TObject);
begin
  GameSettings:= GC_DflSettings;
  SetValues;
end;

procedure TSettingDialog.FormShow(Sender: TObject);
begin
  Caption                  := LS(S_SettingDlgTitle);
  GrpKeyCount.Caption      := LS(S_SettingKeyCount);
  ChkFixedStart.Caption    := LS(S_SettingFixedStart);
  ChkPlayTunes.Caption     := LS(S_SettingPlayTunes);
  ChkBlackKeys.Caption     := LS(S_SettingBlackKeys);
  GrpSpeed.Caption         := LS(S_SettingSpeed);
  LblSlow.Caption          := LS(S_SettingSlow);
  LblFast.Caption          := LS(S_SettingFast);
  BtnDefault.Caption       := LS(S_SettingDefault);
  BtnCancel.Caption        := LS(S_SettingCancel);
  BtnOK.Caption            := LS(S_SettingOK);
  SetValues;
end;

procedure TSettingDialog.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  GetValues;
end;

procedure TSettingDialog.ScrlSpeedChange(Sender: TObject);
begin
  LblSpeed.Caption:= IntToStr(ScrlSpeed.Position);
end;

end.
